<?php 
set_time_limit(4000);
ob_start();
$start = microtime(true);


// your ramdisk path
$path = '/dev/shm/';
// will empty ramdisk
@deleteFiles($path.'yoursite/');
//xmap must be installed and sitemap must include all pages
$source = 'http://www.yoursite.com/index.php?option=com_xmap&sitemap=1&view=xml';
// read all the pages in sitemap
@createCache($source);

$str = ob_get_clean();
$end = microtime(true);
$cas = ($end-$start);
$str = "Total time: ".$cas.' sec'."\n".$str;
// if you don't need email, just commend this line
mail_utf8('bench@example.com', 'Cache Created', $str, 'benchmark@example.com');
//mail_utf8('bench@rupostel.sk', 'Cache Created', 'too long', 'benchmark@rupostel.sk');


function mail_utf8($to, $subject = '(No subject)', $message = '', $from) {
  $header = 'MIME-Version: 1.0' . "\n" . 'Content-type: text/plain; charset=UTF-8'
    . "\n" . 'From: stAn <' . $from . ">\n";
  mail($to, '=?UTF-8?B?'.base64_encode($subject).'?=', $message, $header);
} 

function createCache($source)
{
$pocet = 0;
$time = microtime(true);
$sitemap = new SimpleXMLElement($source,null,true);

foreach($sitemap as $url) {
// read contents and do nothing 
 $output =  @file_get_contents("$url->loc");
// slow down, we don't want to kill mysql server, if you have long execution time you can set this much higher
 usleep(40);
 $pocet++;
 
}
 $time2 = microtime(true);
 $ms = ($time2-$time)*1000;
 echo $ms.': '.$source."number of pages: ".$pocet."\n";

}
// code from very helpfull site: http://snipplr.com/view/1827/delete-files-and-subdirectory-files/
function deleteFiles($path, $match='*', $delSubdirFiles = true)
{
 static $deleted = 0;
 $dirs = glob($path."*", GLOB_NOSORT);
 $files = glob($path.$match, GLOB_NOSORT);
 foreach ($files as $file) {
  if (is_file($file)) { unlink($file); $deleted++; } 
  }
 if ($delSubdirFiles) {
  foreach ($dirs as $dir) {
  if (is_dir($dir)) {
  $dir = basename($dir)."/";
  deleteFiles($path.$dir, $match);
  
  }
  }
 }
 return $deleted;
}

?>